#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2two25004xi.py">
#<abstract4xi abstract = "fires to direction two and to distance 2500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2two25004xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2TWO - COORDINATE SIGNS OF SHOOT2TWO4XI: (X + ,Y - ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2two25004xi

#"
#/>

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

# -------------------------------------------------------------------------------------------------
# 2500
# -------------------------------------------------------------------------------------------------
shot2two25004xi = {
        1:'1004x-894y-2107z',
        2:'100x-1327y-2116z',
        3:'1033x-827y-2120z',
        4:'1058x-759y-2133z',
        5:'1059x-49y-2264z',
        6:'1077x-106y-2253z',
        7:'1078x-691y-2146z',
        8:'1090x-2232y-277z',
        9:'1092x-166y-2242z',
        10:'1094x-623y-2159z',
        11:'1104x-228y-2231z',
        12:'1106x-555y-2172z',
        13:'1112x-291y-2219z',
        14:'1113x-488y-2184z',
        15:'1116x-355y-2208z',
        16:'1117x-421y-2196z',
        17:'1204x-2169y-301z',
        18:'1287x-2142y-23z',
        19:'1314x-2101y-326z',
        20:'1397x-2072y-48z',
        21:'1420x-2026y-351z',
        22:'1503x-1995y-73z',
        23:'151x-1030y-2272z',
        24:'1522x-1946y-376z',
        25:'1605x-1913y-98z',
        26:'1619x-1861y-400z',
        27:'167x-1299y-2129z',
        28:'1702x-1826y-123z',
        29:'1712x-1771y-425z',
        30:'1795x-1733y-148z',
        31:'1799x-1676y-450z',
        32:'179x-1615y-1899z',
        33:'1881x-1576y-474z',
        34:'1882x-1636y-173z',
        35:'1957x-1473y-499z',
        36:'1963x-1534y-198z',
        37:'201x-998y-2282z',
        38:'2027x-1365y-523z',
        39:'2039x-1428y-223z',
        40:'2091x-1255y-548z',
        41:'2109x-1318y-248z',
        42:'2149x-1141y-572z',
        43:'2173x-1204y-272z',
        44:'219x-2488y-102z',
        45:'2200x-1024y-596z',
        46:'2230x-1088y-297z',
        47:'2245x-905y-621z',
        48:'2282x-968y-322z',
        49:'2284x-785y-645z',
        50:'2315x-662y-669z',
        51:'231x-1267y-2142z',
        52:'2326x-846y-347z',
        53:'2340x-539y-693z',
        54:'2358x-414y-717z',
        55:'2364x-722y-372z',
        56:'2369x-289y-741z',
        57:'2371x-40y-788z',
        58:'2374x-164y-765z',
        59:'2394x-597y-396z',
        60:'2414x-647y-7z',
        61:'2418x-470y-421z',
        62:'2435x-342y-446z',
        63:'2445x-213y-470z',
        64:'2445x-519y-32z',
        65:'2448x-85y-495z',
        66:'2468x-390y-57z',
        67:'247x-964y-2293z',
        68:'2484x-261y-81z',
        69:'2494x-130y-106z',
        70:'260x-1585y-1915z',
        71:'292x-1232y-2155z',
        72:'302x-965y-2395z',
        73:'31x-1351y-2102z',
        74:'338x-1550y-1931z',
        75:'348x-2472y-127z',
        76:'350x-1194y-2167z',
        77:'405x-1154y-2180z',
        78:'414x-1512y-1947z',
        79:'456x-1111y-2192z',
        80:'45x-1085y-2251z',
        81:'477x-2449y-152z',
        82:'486x-1469y-1962z',
        83:'504x-1066y-2204z',
        84:'549x-1018y-2215z',
        85:'556x-1424y-1978z',
        86:'590x-969y-2227z',
        87:'604x-2419y-177z',
        88:'621x-1374y-1993z',
        89:'627x-919y-2238z',
        90:'661x-867y-2249z',
        91:'683x-1322y-2008z',
        92:'691x-814y-2260z',
        93:'694x-20y-2401z',
        94:'715x-58y-2394z',
        95:'717x-760y-2270z',
        96:'729x-2382y-202z',
        97:'735x-98y-2387z',
        98:'739x-706y-2281z',
        99:'741x-1267y-2023z',
        100:'752x-141y-2379z',
        101:'758x-651y-2291z',
        102:'767x-186y-2371z',
        103:'773x-596y-2301z',
        104:'779x-233y-2363z',
        105:'784x-542y-2310z',
        106:'788x-281y-2355z',
        107:'792x-488y-2320z',
        108:'794x-331y-2347z',
        109:'795x-1210y-2037z',
        110:'796x-382y-2338z',
        111:'796x-435y-2329z',
        112:'846x-1150y-2051z',
        113:'852x-2339y-227z',
        114:'88x-2497y-77z',
        115:'892x-1088y-2066z',
        116:'933x-1025y-2080z',
        117:'95x-1641y-1882z',
        118:'971x-960y-2093z',
        119:'973x-2289y-252z',
        120:'99x-1059y-2262z',
        121:'9x-1663y-1866z'}
        
        
#"
#"/>

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2500two4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2500two4xi(queue2two, consumer_channel2two, publisher_channel2two):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2500TWO4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2500TWO4XI -  QUEUE2TWO: ", queue2two)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2500TWO4XI -  CONSUMER_CHANNEL2TWO: ", consumer_channel2two)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2500TWO4XI -  PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2500TWO4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2two.put(shot2two25004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2500TWO4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2500TWO4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2500TWO4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2two8shot2two25004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2two8shot2two25004xi</nack2put4xi>" 
            
        publisher_channel2two.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2500TWO4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2500TWO4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2500TWO4XI - RETURNING QUEUE OBJECT QUEUE2TWO: ", queue2two, " - TIME: ", time4xi())  
        # 
            
    return queue2two    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verbkb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2two25004xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
        